; Driver pre posuvny register 74xx595 cez port D
;
; * Konstanty
; w595_Port	- Port
; w595_Dat 	- Pin Data
; w595_Clk	- Pin Clock
; w595_Stb	- Pin Strobe
; R17 - B - Datovy register
; * Procedury
;   * w595_SendByte ( R17 - B )		Poslat Byte
;   * w595_Print					Vykreslit
;
; Vytvoril: Vladimir Visnovsky

; Konstanty: -----------------------------------------------------------
;
; Pridelovanie portu
.EQU w595_Port	=	PortB		; Port
.EQU w595_Dat 	=	0			; Pin Data
.EQU w595_Clk	= 	1			; Pin Clock
.EQU w595_Stb	= 	2			; Pin Strobe
; Procedury
 rjmp	w595_EndPage

; Poslat Byte do registra 595 
w595_SendByte:
 ; Nacitanie portu 
 cbi	w595_Port	, w595_Clk
 cbi	w595_Port	, w595_Dat
 cbi	w595_Port	, w595_Stb 
 in		R16			, w595_Port 
 ; 7. Bit ------------------
 bst	R17			, 7			; Poslanie bitu 
 bld	R16			, w595_Dat
 out	w595_Port	, R16	 
 set							; Generovanie inpulzu Clk
 bld	R16			, w595_Clk	 
 out	w595_Port	, R16	 
 clt							; Ukoncenie inpulzu Clk
 bld	R16			, w595_Clk
 out	w595_Port	, R16	;
 ; 6. Bit ------------------
 bst	R17			, 6			; Poslanie bitu 
 bld	R16			, w595_Dat
 out	w595_Port	, R16	 
 set							; Generovanie inpulzu Clk
 bld	R16			, w595_Clk	 
 out	w595_Port	, R16	 
 clt							; Ukoncenie inpulzu Clk
 bld	R16			, w595_Clk
 out	w595_Port	, R16	;
 ; 5. Bit ------------------
 bst	R17			, 5			; Poslanie bitu 
 bld	R16			, w595_Dat
 out	w595_Port	, R16	 
 set							; Generovanie inpulzu Clk
 bld	R16			, w595_Clk	 
 out	w595_Port	, R16	 
 clt							; Ukoncenie inpulzu Clk
 bld	R16			, w595_Clk
 out	w595_Port	, R16	;
 ; 4. Bit ------------------
 bst	R17			, 4			; Poslanie bitu 
 bld	R16			, w595_Dat
 out	w595_Port	, R16	 
 set							; Generovanie inpulzu Clk
 bld	R16			, w595_Clk	 
 out	w595_Port	, R16	 
 clt							; Ukoncenie inpulzu Clk
 bld	R16			, w595_Clk
 out	w595_Port	, R16	;
 ; 3. Bit ------------------
 bst	R17			, 3			; Poslanie bitu 
 bld	R16			, w595_Dat
 out	w595_Port	, R16	 
 set							; Generovanie inpulzu Clk
 bld	R16			, w595_Clk	 
 out	w595_Port	, R16	 
 clt							; Ukoncenie inpulzu Clk
 bld	R16			, w595_Clk
 out	w595_Port	, R16	;
 ; 2. Bit ------------------
 bst	R17			, 2			; Poslanie bitu 
 bld	R16			, w595_Dat
 out	w595_Port	, R16	 
 set							; Generovanie inpulzu Clk
 bld	R16			, w595_Clk	 
 out	w595_Port	, R16	 
 clt							; Ukoncenie inpulzu Clk
 bld	R16			, w595_Clk
 out	w595_Port	, R16	;
 ; 1. Bit ------------------
 bst	R17			, 1			; Poslanie bitu 
 bld	R16			, w595_Dat
 out	w595_Port	, R16	 
 set							; Generovanie inpulzu Clk
 bld	R16			, w595_Clk	 
 out	w595_Port	, R16	 
 clt							; Ukoncenie inpulzu Clk
 bld	R16			, w595_Clk
 out	w595_Port	, R16	;
 ; 0. Bit ------------------
 bst	R17			, 0			; Poslanie bitu 
 bld	R16			, w595_Dat
 out	w595_Port	, R16	 
 set							; Generovanie inpulzu Clk
 bld	R16			, w595_Clk	 
 out	w595_Port	, R16	 
 clt							; Ukoncenie inpulzu Clk
 bld	R16			, w595_Clk
 out	w595_Port	, R16	;
 ; Koniec vysielania
 ;ret

; Zapamatat a vykreslit
w595_Print:
 sbi 	w595_Port	, w595_Stb		; Vyzdvihnutie 2. bytu
 cbi	w595_Port	, w595_Stb
 ;ret
 reti
; Koniec strany
w595_EndPage:
 
